Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 89409)
+++ main/pbx.c	(working copy)
@@ -2676,7 +2676,6 @@
 		if (!strcmp(ast_get_context_name(c), context))
 			return c;
 	}
-	ast_unlock_contexts();
 
 	return NULL;
 }
@@ -2694,8 +2693,8 @@
 	if (c) {
 		/* found, remove include from this context ... */
 		ret = ast_context_remove_include2(c, include, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -2747,8 +2746,8 @@
 	if (c) {
 		/* remove switch from this context ... */
 		ret = ast_context_remove_switch2(c, sw, data, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -2797,8 +2796,8 @@
 
 	if (c) { /* ... remove extension ... */
 		ret = ast_context_remove_extension2(c, extension, priority, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -4021,8 +4020,8 @@
 
 	if (c) {
 		ret = ast_context_add_include2(c, include, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -4345,8 +4344,8 @@
 
 	if (c) { /* found, add switch to this context */
 		ret = ast_context_add_switch2(c, sw, data, eval, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -4432,8 +4431,8 @@
 
 	if (c) {
 		ret = ast_context_remove_ignorepat2(c, ignorepat, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -4475,8 +4474,8 @@
 
 	if (c) {
 		ret = ast_context_add_ignorepat2(c, value, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
@@ -4542,8 +4541,8 @@
 	if (c) {
 		ret = ast_add_extension2(c, replace, extension, priority, label, callerid,
 			application, data, datad, registrar);
-		ast_unlock_contexts();
 	}
+	ast_unlock_contexts();
 	return ret;
 }
 
